# Spojnik.awk (MS-DOS version)
#    usage:  gawk -f spj.awk plik, plik...
# 
# Dodaje nie/lamliwe spacje po sp/ojnikach, przed inicja/lami 
# oraz do niekt/orych skr/ot/ow. Zamienia /laczniki w odpowiednich 
# miejscach na p/o/lpauzy.
#
# Author: TP (5.4.96)
#

BEGIN {
   stdio = "con";
   digit = "[0123456789]"; 
   capletter = "[A-Z]";  # Mazovia format
   lowletter = "[a-z]";  # Mazovia format
   spojnik = "[AIOUWZaiouwz]"; 
   wspace = "[ \\t\\n]+";
}

# wymie _co_ w kontekcie _bef_ _aft_ na _na_
# designed by: Marek Ryko

function exch (bef, co, aft, na) {
   while (match(para, bef co aft) > 0) {
       match(para, bef co aft);
       nowy = substr(para, 1, RSTART) na substr(para, RSTART+RLENGTH-1);
       para = nowy;
   }
}

# wymie _co_ w kontekcie _bef_ _aft_ na _na_
# original idea: Marek Ryko

function xexch (bef, co, aft, na) {
   while (match(para, bef co aft) > 0) {
       match(para, bef co aft); R1 = RSTART; L1 = RLENGTH;

       test = substr(para,RSTART,RLENGTH);

       test1 = match(test,bef); R2 = RSTART; L2 = RLENGTH;
       test2 = match(test,aft); R3 = RSTART; L3 = RLENGTH;

       nowy = substr(para, 1, R1 + L2 - 1) na substr(para, R1 + L1 - L3);
       para = nowy;
   }
}


function print_para() {
   len = 0;
   words = split(para, paralist," ");
   for (i=1; i<=words; i++) {
      len += length(paralist[i]);
      ##print len, paralist[i] >> stdio;

      if ( ++len >= 60 ) { printf "%s\n", paralist[i]; len = 0 }
      else { printf "%s ", paralist[i]; }
   }
   if (len) { printf "\n\n"; } else { printf "\n";}
}

function process_para() {
   print "Paragraph: ", length(para), "bytes" >> stdio;

   gsub(/[ \t\n]+a[ \t\n]+/, " a~", para); gsub(/\~a /, "~a~", para);
   gsub(/[ \t\n]+i[ \t\n]+/, " i~", para); gsub(/\~i /, "~i~", para);
   gsub(/[ \t\n]+o[ \t\n]+/, " o~", para); gsub(/\~o /, "~o~", para);
   gsub(/[ \t\n]+u[ \t\n]+/, " u~", para); gsub(/\~u /, "~u~", para);
   gsub(/[ \t\n]+w[ \t\n]+/, " w~", para); gsub(/\~w /, "~w~", para);
   gsub(/[ \t\n]+z[ \t\n]+/, " z~", para); gsub(/\~z /, "~z~", para);

   gsub(/[ \t\n]+A[ \t\n]+/, " A~", para); gsub(/\~A /, "~A~", para);
   gsub(/[ \t\n]+I[ \t\n]+/, " I~", para); gsub(/\~I /, "~I~", para);
   gsub(/[ \t\n]+O[ \t\n]+/, " O~", para); gsub(/\~O /, "~O~", para);
   gsub(/[ \t\n]+U[ \t\n]+/, " U~", para); gsub(/\~U /, "~U~", para);
   gsub(/[ \t\n]+W[ \t\n]+/, " W~", para); gsub(/\~W /, "~W~", para);
   gsub(/[ \t\n]+Z[ \t\n]+/, " Z~", para); gsub(/\~Z /, "~Z~", para);
   
   gsub(/[ \t\n]+r\./, "~r.",para); # year

   #intials#
   xexch(capletter, "\\.[ \t\n]+", capletter lowletter, "\.\~");
   xexch(capletter, "\\.[ \t\n]+", capletter "\\.\\~", "\.\~");

   #endashes#
   exch(digit,"-",digit, "--");
   xexch(digit, wspace "-" wspace, digit, "--");

   #now we can convert emdashes#
   gsub(wspace "-" wspace, " -- ", para);

   print_para();
   para = "";
}

{ para = para " " $0; if (match($0,/^[\t ]*$/) ){process_para()} }
END {process_para(); }


